// A custom interface to allow the user to set parameters
#ifndef __INF_MFS__
#define __INF_MFS__

typedef struct _MFS_FileList
{
	struct _MFS_FileList	*Next;
	WCHAR	Filename[1];	// more bytes may follow
} MFS_FileList;

#ifdef __cplusplus
extern "C" {
#endif

	// {999311C4-410D-11d4-868C-0000F8069A8F}
	DEFINE_GUID(IID_IIPMFSrc, 
	0x999311c4, 0x410d, 0x11d4, 0x86, 0x8c, 0x0, 0x0, 0xf8, 0x6, 0x9a, 0x8f);

    DECLARE_INTERFACE_(IIPMFSrc, IUnknown)
    {
        STDMETHOD(get_FileList) (THIS_
					MFS_FileList	**firstFile,	// file list
					LONGLONG		*skip
                 ) PURE;

        STDMETHOD(put_FileList) (THIS_
					MFS_FileList	*firstFile,		// file list
					LONGLONG		skip
                 ) PURE;

        STDMETHOD(get_MediaType) (THIS_
					CMediaType		**mediaType			// the media type
                 ) PURE;

        STDMETHOD(load_MediaType) (THIS_
					CMediaType		**mediaType,		// the media type
					WCHAR			*filename
                 ) PURE;

        STDMETHOD(put_MediaType) (THIS_
					const CMediaType		*mediaType			// the media type
                 ) PURE;

        STDMETHOD(put_MediaType) (THIS_
					const AM_MEDIA_TYPE		*mediatype			// the media type
                 ) PURE;

        STDMETHOD(put_MediaType) (THIS_
					const GUID				*majortype,			// the major type
					const GUID				*minortype			// the minor type
                 ) PURE;

    };

#ifdef __cplusplus
}
#endif

#endif // __INF_MFS__
