#include <windows.h>
#include <windowsx.h>
#include <streams.h>
#include <commctrl.h>
#include <olectl.h>
#include <memory.h>
#include <stdlib.h>
#include <stdio.h>
#include <tchar.h>
#include "resource.h"
#include "mfs_uids.h"
#include "inf_mfs.h"
#include "multfilesrc.h"
#include "mfs_prop_file.h"

//
// CreateInstance
//
// Used by the ActiveMovie base classes to create instances
//
CUnknown *CMFSPropertiesFile::CreateInstance(LPUNKNOWN lpunk, HRESULT *phr)
{
    CUnknown *punk = new CMFSPropertiesFile(lpunk, phr);
    if (punk == NULL) {
	*phr = E_OUTOFMEMORY;
    }
    return punk;

} // CreateInstance


//
// Constructor
//
CMFSPropertiesFile::CMFSPropertiesFile(LPUNKNOWN pUnk, HRESULT *phr) :
    CBasePropertyPage(NAME("MFSrc filter Property Page - Filelist"),
                      pUnk,IDD_FILELIST_PROP,IDS_FILELIST_TITLE),
    m_pIPMFSrc(NULL),
	m_first(NULL),
	m_llskip(0),
    m_bIsInitialized(FALSE)
{
	ASSERT(phr);
} // (Constructor)


static TCHAR	strFile[MAX_PATH]="";		// this should be large enough

static OPENFILENAME	ofn=
{
	sizeof(OPENFILENAME),		// lStructSize
	NULL,						// hwndOwner
    NULL,						// hInstance
    NULL,						// lpstrFilter 
    NULL,						// lpstrCustomFilter
    0,							// nMaxCustFilter
    0,							// nFilterIndex
    strFile,					// lpstrFile
    sizeof(strFile),			// nMaxFile
    NULL,						// lpstrFileTitle
    0,							// nMaxFileTitle
    NULL,						// lpstrInitialDir
    "browse file",				// lpstrTitle
    OFN_FILEMUSTEXIST|OFN_LONGNAMES,		// Flags
    0,							// nFileOffset
    0,							// nFileExtension
    NULL,						// lpstrDefExt
    0,							// lCustData
    NULL,						// lpfnHook
    NULL						// lpTemplateName
};


//
// OnReceiveMessage
//
// Handles the messages for our property window
//
BOOL CMFSPropertiesFile::OnReceiveMessage(HWND hwnd,
                                          UINT uMsg,
                                          WPARAM wParam,
                                          LPARAM lParam)
{
    switch (uMsg)
    {
        case WM_COMMAND:
        {
           if(LOWORD(wParam)==IDC_FILELIST && HIWORD(wParam)==LBN_SELCHANGE) 
		   {
			    HWND	hLB;
				TCHAR	text[MAX_PATH];
				int		index;

				hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
				index=(int)SendMessage(hLB, LB_GETCURSEL, (WPARAM)0, (LPARAM)0);
				SendMessage(hLB, LB_GETTEXT, (WPARAM)index, (LPARAM)text);

				SetDlgItemText(hwnd, IDC_FILE, text);
		   }
           else if(LOWORD(wParam)==IDC_SET) 
		   {
			    HWND	hLB;
				TCHAR	text[MAX_PATH];
				int		index;

				hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
				index=(int)SendMessage(hLB, LB_GETCURSEL, (WPARAM)0, (LPARAM)0);
				GetDlgItemText(hwnd, IDC_FILE, text, MAX_PATH);

				SendMessage(hLB, LB_DELETESTRING, (WPARAM)index, (LPARAM)0);
				SendMessage(hLB, LB_INSERTSTRING, (WPARAM)index, (LPARAM)text);
				SendMessage(hLB, LB_SETCURSEL, (WPARAM)index, (LPARAM)0);
		   }
           else if(LOWORD(wParam)==IDC_ADD) 
		   {
			    HWND	hLB;
				TCHAR	text[MAX_PATH];
				int		index;

				GetDlgItemText(hwnd, IDC_FILE, text, MAX_PATH);

				hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
				index=(int)SendMessage(hLB, LB_ADDSTRING, (WPARAM)0, (LPARAM)text);
				SendMessage(hLB, LB_SETCURSEL, (WPARAM)index, (LPARAM)0);
		   }
           else if(LOWORD(wParam)==IDC_DEL) 
		   {
			    HWND	hLB;
				int		index;

				hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
				index=(int)SendMessage(hLB, LB_GETCURSEL, (WPARAM)0, (LPARAM)0);
				if(index>=0)
				{
					SendMessage(hLB, LB_DELETESTRING, (WPARAM)index, (LPARAM)0);
				}
		   }
           else if(LOWORD(wParam)==IDC_UP) 
		   {
			    HWND	hLB;
				int		index;

				hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
				index=(int)SendMessage(hLB, LB_GETCURSEL, (WPARAM)0, (LPARAM)0);
				if(index>0)
				{
					TCHAR	text[MAX_PATH];

					SendMessage(hLB, LB_GETTEXT, (WPARAM)index, (LPARAM)text);
					SendMessage(hLB, LB_DELETESTRING, (WPARAM)index, (LPARAM)0);

					SendMessage(hLB, LB_INSERTSTRING, (WPARAM)index-1, (LPARAM)text);
					SendMessage(hLB, LB_SETCURSEL, (WPARAM)index-1, (LPARAM)0);
				}
		   }
           else if(LOWORD(wParam)==IDC_DOWN) 
		   {
			    HWND	hLB;
				int		index, count;

				hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
				index=(int)SendMessage(hLB, LB_GETCURSEL, (WPARAM)0, (LPARAM)0);
				count=(int)SendMessage(hLB, LB_GETCOUNT, (WPARAM)0, (LPARAM)0);
				if(index>=0 && index<(count-1))
				{
					TCHAR	text[MAX_PATH];

					SendMessage(hLB, LB_GETTEXT, (WPARAM)index, (LPARAM)text);
					SendMessage(hLB, LB_DELETESTRING, (WPARAM)index, (LPARAM)0);

					SendMessage(hLB, LB_INSERTSTRING, (WPARAM)index+1, (LPARAM)text);
					SendMessage(hLB, LB_SETCURSEL, (WPARAM)index+1, (LPARAM)0);
				}
		   }
           else if(LOWORD(wParam)==IDC_BROWSE) 
		   {
				ofn.hwndOwner=hwnd;

				if(GetOpenFileName(&ofn)==TRUE)
				{
				    HWND	hLB;
					int		index;
				
					hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
					index=(int)SendMessage(hLB, LB_ADDSTRING, (WPARAM)0, (LPARAM)strFile);
					SetDlgItemText(hwnd, IDC_FILE, strFile);
					SendMessage(hLB, LB_SETCURSEL, (WPARAM)index, (LPARAM)0);
				}
		   }

           if (m_bIsInitialized)
            {
                m_bDirty = TRUE;
                if (m_pPageSite)
                {
                    m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
                }
            }
            return (LRESULT) 1;
        }

    }
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);

} // OnReceiveMessage


//
// OnConnect
//
// Called when we connect to a transform filter
//
HRESULT CMFSPropertiesFile::OnConnect(IUnknown *pUnknown)
{
    ASSERT(m_pIPMFSrc == NULL);

    HRESULT hr = pUnknown->QueryInterface(IID_IIPMFSrc, (void **) &m_pIPMFSrc);
    if (FAILED(hr)) {
        return E_NOINTERFACE;
    }

    ASSERT(m_pIPMFSrc);

	FreeFileList();

	int				len;
	MFS_FileList	*fl, *pfl, *first;

    // Get the initial image FX property
    m_pIPMFSrc->get_FileList(&first, &m_llskip);
	
	m_first=NULL;
	while(first)
	{
        len=lstrlenW(first->Filename);

		fl=(MFS_FileList *)CoTaskMemAlloc(sizeof(MFS_FileList)+len*sizeof(WCHAR));
        if(fl!=NULL) 
		{
			fl->Next=NULL;
		    CopyMemory(fl->Filename, first->Filename, (len+1)*sizeof(WCHAR));

			if(m_first==NULL)
				m_first=fl;
			else
				pfl->Next=fl;

			pfl=fl;
        }

		first=first->Next;
	}

    m_bIsInitialized = FALSE ;
    return NOERROR;

} // OnConnect


//
// OnDisconnect
//
// Likewise called when we disconnect from a filter
//
HRESULT CMFSPropertiesFile::OnDisconnect()
{
    // Release of Interface after setting the appropriate old effect value

    if (m_pIPMFSrc == NULL) {
        return E_UNEXPECTED;
    }

    m_pIPMFSrc->Release();
    m_pIPMFSrc = NULL;
    return NOERROR;

} // OnDisconnect


//
// OnActivate
//
// We are being activated
//
HRESULT CMFSPropertiesFile::OnActivate()
{
	HWND			hLB;
	MFS_FileList	*fl;
	char			text[MAX_PATH], text2[MAX_PATH];
	LONGLONG		ll;
	int				i, c;

	m_bIsInitialized = TRUE;

	hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
	fl=m_first;
	while(fl)
	{
		SendMessageW(hLB, LB_ADDSTRING, (WPARAM)0, (LPARAM)fl->Filename);
		fl=fl->Next;
	}

	i=0;
	ll=m_llskip;
	do
	{
		c=(int)(ll%10);
		text[i]=(char)c+'0';

		ll/=10;
		i++;
	}while(ll!=0);
	text[i]=0;
	text2[i]=0;

	c=strlen(text)-1;
	// now let's reverse the string
	for(i=0; i<=c; i++)
		text2[c-i]=text[i];

	SetDlgItemTextA(m_Dlg, IDC_SKIP, text2);

    return NOERROR;
} // OnActivate

//
// OnDeactivate
//
// We are being deactivated
//
HRESULT CMFSPropertiesFile::OnDeactivate(void)
{
    m_bIsInitialized = FALSE;

    GetControlValues();
    return NOERROR;

} // OnDeactivate


//
// OnApplyChanges
//
// Apply any changes so far made
//
HRESULT CMFSPropertiesFile::OnApplyChanges()
{
	GetControlValues();

    ASSERT(m_pIPMFSrc);
    m_pIPMFSrc->put_FileList(m_first, m_llskip);

    return NOERROR;
} // OnApplyChanges

void CMFSPropertiesFile::GetControlValues()
{
	HWND			hLB;
	unsigned int	i, count, len;
	MFS_FileList	*fl, *pfl;
	char			text[MAX_PATH];

	FreeFileList();

	hLB=GetDlgItem(m_Dlg, IDC_FILELIST);
	count=(int)SendMessage(hLB, LB_GETCOUNT, (WPARAM)0, (LPARAM)0);

	m_first=NULL;
	for(i=0; i<count; i++)
	{
		len=SendMessage(hLB, LB_GETTEXTLEN, (WPARAM)i, (LPARAM)0);

		fl=(MFS_FileList *)CoTaskMemAlloc(sizeof(MFS_FileList)+len*sizeof(WCHAR));
		if(fl!=NULL)
		{
			fl->Next=NULL;
			SendMessageW(hLB, LB_GETTEXT, (WPARAM)i, (LPARAM)fl->Filename);

			if(m_first==NULL)
				m_first=fl;
			else
				pfl->Next=fl;

			pfl=fl;
		}
	}

	GetDlgItemTextA(m_Dlg, IDC_SKIP, text, MAX_PATH);
	m_llskip=0;
	for(i=0; i<strlen(text); i++)
	{
		m_llskip*=10;
		m_llskip+=(text[i]-'0');
	}
} // OnApplyChanges
